#pragma once
#ifndef HW_LIB_OLED_FONT_CHUC_H
#define HW_LIB_OLED_FONT_CHUC_H


typedef struct {
    uint8_t unicode[2];
    uint8_t data[32];
} Chinese_t;

uint8_t Hzk_size = 16;

Chinese_t Hzk[] = {
        {
                // Original: 字
                {0x5B, 0x57},
                {
                        0x10, 0x0C, 0x04, 0x24, 0x24, 0x24, 0x25, 0x26, 0xA4, 0x64, 0x24, 0x04, 0x04, 0x14, 0x0C, 0x00,
                        0x02, 0x02, 0x02, 0x02, 0x02, 0x42, 0x82, 0x7F, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x00,
                }
        },
        {
                // Original: 库
                {0x5E, 0x93},
                {
                        0x00, 0x00, 0xFC, 0x24, 0x24, 0xA4, 0x64, 0x3D, 0xA6, 0x24, 0x24, 0x24, 0x24, 0x24, 0x04, 0x00,
                        0x40, 0x30, 0x0F, 0x10, 0x13, 0x12, 0x12, 0x12, 0xFF, 0x12, 0x12, 0x12, 0x12, 0x10, 0x10, 0x00,
                }
        },
        {
                // Original: 生
                {0x75, 0x1F},
                {
                        0x80, 0x40, 0x30, 0x1E, 0x10, 0x10, 0x10, 0xFF, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x00, 0x00,
                        0x40, 0x40, 0x42, 0x42, 0x42, 0x42, 0x42, 0x7F, 0x42, 0x42, 0x42, 0x42, 0x42, 0x40, 0x40, 0x00,
                }
        },
        {
                // Original: 成
                {0x62, 0x10},
                {
                        0x00, 0x00, 0xF8, 0x88, 0x88, 0x88, 0x88, 0x08, 0x08, 0xFF, 0x08, 0x09, 0x0A, 0xC8, 0x08, 0x00,
                        0x80, 0x60, 0x1F, 0x00, 0x10, 0x20, 0x1F, 0x80, 0x40, 0x21, 0x16, 0x18, 0x26, 0x41, 0xF8, 0x00,
                }
        },
        {
                // Original: 测
                {0x6D, 0x4B},
                {
                        0x10, 0x60, 0x02, 0x8C, 0x00, 0xFE, 0x02, 0xF2, 0x02, 0xFE, 0x00, 0xF8, 0x00, 0xFF, 0x00, 0x00,
                        0x04, 0x04, 0x7E, 0x01, 0x80, 0x47, 0x30, 0x0F, 0x10, 0x27, 0x00, 0x47, 0x80, 0x7F, 0x00, 0x00,
                }
        },
        {
                // Original: 试
                {0x8B, 0xD5},
                {
                        0x40, 0x40, 0x42, 0xCC, 0x00, 0x90, 0x90, 0x90, 0x90, 0x90, 0xFF, 0x10, 0x11, 0x16, 0x10, 0x00,
                        0x00, 0x00, 0x00, 0x3F, 0x10, 0x28, 0x60, 0x3F, 0x10, 0x10, 0x01, 0x0E, 0x30, 0x40, 0xF0, 0x00,
                }
        },
};

uint16_t find_chinese_data(uint8_t unicode_high, uint8_t unicode_low) {
    for (int i = 0; i < sizeof(Hzk) / sizeof(Chinese_t); ++i) {
        if (Hzk[i].unicode[0] == unicode_high && Hzk[i].unicode[1] == unicode_low) {
            return i;
        }
    }
    return NULL;
}


#endif //HW_LIB_OLED_FONT_CHUC_H
